// Prevents additional console window on Windows in release, DO NOT REMOVE!!
#![cfg_attr(not(debug_assertions), windows_subsystem = "windows")]

use std::{io::Cursor, path::PathBuf};
use std::io::Seek;
use serde_json::{Result, Value};

mod ftp;

// Learn more about Tauri commands at https://tauri.app/v1/guides/features/command
#[tauri::command]
fn greet(name: &str) -> String {
    format!("Hello, {}! You've been greeted from Rust!", name)
}

#[tauri::command]
fn get_modpacks() -> Vec<String> {
    let mut buf = Cursor::new(vec![]);
    ftp::ftp_retr(PathBuf::new().join("modpacks.json"), &mut buf, |_| return);
    buf.rewind();
    let v: Value = serde_json::from_reader(buf).unwrap();
    println!("{}", v[0]["name"]);
    let mut packs: Vec<String> = Vec::new();
    for pack in v.as_array().unwrap() {
        packs.push(pack["name"].to_string());
    }
    return packs;
}

fn main() {
    println!("{}", get_modpacks()[0]);
    tauri::Builder::default()
        .invoke_handler(tauri::generate_handler![greet])
        .run(tauri::generate_context!())
        .expect("error while running tauri application");
}
